
%{
#include "dvbrcp.tab.h"
#include <stdio.h>

int	line;

%}

%x str

%%
            char string_buf[256];
            char *string_buf_ptr;


CHANNEL		{ return T_CHANNEL; }
LNB		{ return T_LNB; }
ID		{ return T_ID; }
TYPE		{ return T_TYPE; }
LOF1		{ return T_LOF1; }
LOF2		{ return T_LOF2; }
SLOF		{ return T_SLOF; }
DISEQCNR	{ return T_DISEQCNR; }
SAT		{ return T_SAT; }
NAME		{ return T_NAME; }
LNBID		{ return T_LNBID; }
FMIN		{ return T_FMIN; }
FMAX		{ return T_FMAX; }
TRANSPONDER	{ return T_TRANSPONDER; }
SATID		{ return T_SATID; }
FREQ		{ return T_FREQ; }
POL		{ return T_POL; }
SRATE		{ return T_SRATE; }
FEC		{ return T_FEC; }
TPID		{ return T_TPID; }
TTPID		{ return T_TTPID; }
SID		{ return T_SID; }

[0-9]+"/"[0-9]+	{ return T_FECS; }

\"		{ string_buf_ptr = string_buf; BEGIN(str); }

[a-fA-F0-9]+	{ yylval.s = strdup(yytext); return T_NUM; }

\n		{ line++; return '\n'; }
[ \t]		{ }
[^\n\t ]	{ return yytext[0]; }
	
<str>\"		{ BEGIN(INITIAL); 
			*string_buf_ptr = '\0'; 
			yylval.s=strdup(string_buf);
			return T_STRING; }
<str>\n 	{ yyerror(); }
<str>\\(.|\n)	{ *string_buf_ptr++ = yytext[1]; }
<str>[^\\\n\"]+ {
			char *yptr = yytext;
			while ( *yptr )
				*string_buf_ptr++ = *yptr++;
		}
%%
#ifndef yywrap
yywrap() { return 1; }
#endif

yyerror (char *s) {
	fprintf (stderr, "%s in line %d\n", s, line);
}

