
#define DEBUG

#ifdef DEBUG
#define dprintf		printf
#else
#define dprintf( a... )
#endif

#define MAX_MCAST_PAYLOAD	(1500-40)
#define TS_PACKET_SIZE		188

enum {
	PID_NONE,
	PID_PMT,
	PID_VIDEO,
	PID_AUDIO,
	PID_OTHER
};

struct stream_s {
	struct stream_s		*next;
	struct channel_s	*channel;
	int			cid,
				sockfd,
				pbufvalid;
	unsigned char 		pbuf[MAX_MCAST_PAYLOAD];
	char			ipaddr[128];
	int			port,
				ttl;
	unsigned int		apid, vpid, opid;
	char			pid0cc;
};

struct pidentry_s {
	unsigned char		type,
				cc;
	time_t			lastvalid;
	struct stream_s		*s;
};

extern struct stream_s	*streams;
